package PRFramework.Core.SupervisedClassifiers.EmergingPatterns.Qualities.Statistical;

import PRFramework.Core.Common.PrDescriptionAttribute;
import PRFramework.Core.SupervisedClassifiers.EmergingPatterns.Qualities.ContingenceTable;
import PRFramework.Core.SupervisedClassifiers.EmergingPatterns.Qualities.ContingenceTableBasedQuality;
import java.io.Serializable;

/**
 * Jaccard Index[1] [1] P.-N. Tan, V. Kumar, J. Srivastava, Selecting the right
 * objective measure for association analysis, Inf. Syst. 29 (4) (2004) 293�313.
 */
@PrDescriptionAttribute("Jacc")
public class JaccardIndexQuality extends ContingenceTableBasedQuality implements Serializable
{

    @Override
    public double GetQuality (ContingenceTable t)
    {
        double result = t.getf_P_C() / (t.getf_P() + t.getf_C() - t.getf_P_C());
        return super.ValidateResult(result);
    }
}
